import React from 'react';
import PropTypes from 'prop-types';
import ReactDOM from 'react-dom';
import Context from '@s-ui/react-context';
import { Provider as ProviderLegacy } from '@s-ui/react-domain-connector';
import { useMount } from '@s-ui/react-hooks';

function renderWidgetOnDOM(_ref) {
  var children = _ref.children,
      context = _ref.context,
      node = _ref.node;
  ReactDOM.render( /*#__PURE__*/React.createElement(Context.Provider, {
    value: context
  }, /*#__PURE__*/React.createElement(ProviderLegacy, context, children)), node);
}

export default function Widget(_ref2) {
  var browser = _ref2.browser,
      children = _ref2.children,
      domain = _ref2.domain,
      i18n = _ref2.i18n,
      _ref2$isVisible = _ref2.isVisible,
      isVisible = _ref2$isVisible === void 0 ? true : _ref2$isVisible,
      selector = _ref2.node,
      _ref2$renderMultiple = _ref2.renderMultiple,
      renderMultiple = _ref2$renderMultiple === void 0 ? false : _ref2$renderMultiple;
  useMount(function () {
    var nodes = document.querySelectorAll(selector);

    if (!nodes.length) {
      return console.warn("[Widget] unable find nodes using selector " + selector); // eslint-disable-line
    } // depending on renderMultiple, get the full array or only the first one


    var nodesToRender = renderMultiple ? [].concat(nodes) : [nodes[0]]; // create the context object

    var context = {
      browser: browser,
      domain: domain,
      i18n: i18n
    };
    isVisible && nodesToRender.map(function (node) {
      return renderWidgetOnDOM({
        children: children,
        context: context,
        node: node
      });
    });
  });
  return null;
}
Widget.propTypes = {
  children: PropTypes.element,
  node: PropTypes.string,
  i18n: PropTypes.object,
  domain: PropTypes.object,
  isVisible: PropTypes.bool,
  browser: PropTypes.object
};